//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Grids.hpp>
#include <Dialogs.hpp>
#include "CSPIN.h"

#include <vcl\Clipbrd.hpp>
#include "mathmatrix.h"
#include "functioncall.h"
#include <Buttons.hpp>
//---------------------------------------------------------------------------

#define ShowMe(a) ShowMessage(a)
union CodeSymbol
{
  char Symbol;
  byte SymbolCode;
};

class TFormMain : public TForm
{
__published:	// IDE-managed Components
  TStatusBar *StatusBar1;
  TGroupBox *GroupBoMatrixList;
  TGroupBox *GroupBoxOperations;
  TGroupBox *GroupBoxFunction;
  TPanel *PanelMatrixMain;
  TPanel *PanelMatrixDown;
  TPanel *PanelMatrixUp;
  TMainMenu *MainMenu;
  TMenuItem *File1;
  TStringGrid *SGMatrix;
  TPanel *PanelAddRemove;
  TButton *BtnAdd;
  TButton *BtnRemove;
  TListView *LVMatrix;
  TCheckBox *CBSingle;
  TLabel *LabelName;
  TLabel *LabelSize;
  TEdit *EditName;
  TLabel *Label3;
  TMenuItem *File;
  TMenuItem *OpenSession1;
  TMenuItem *SaveSesion1;
  TMenuItem *N1;
  TMenuItem *Exit1;
  TComboBox *ComBOperation;
  TButton *BtnCall;
  TMenuItem *Copy1;
  TMenuItem *Paste1;
  TMenuItem *Help1;
  TMenuItem *Contents1;
  TMenuItem *N2;
  TMenuItem *About1;
  TSaveDialog *SaveDialog;
  TOpenDialog *OpenDialog;
  TCSpinEdit *CSpinEditMatrixRows;
  TCSpinEdit *CSpinEditMatrixCols;
  TLabel *LabelEPS;
  TEdit *EditEPS;
  TMenuItem *Undo1;
  TMenuItem *N3;
  TBitBtn *BtnDiv;
  TBitBtn *BtnMult;
  TBitBtn *BtnMin;
  TBitBtn *BitBtn3;
  TBitBtn *BtnCtrl;
  TBitBtn *BtnRndInt;
  TBitBtn *BtnRndFloat;
  TBitBtn *BtnTran;
  TBitBtn *BtnE;
  TBitBtn *BtnLU;
  TBitBtn *BtnTri;
  TBitBtn *BtnInv;
  TBitBtn *BtnIs;
  TBitBtn *BtnDef;
  TBitBtn *BtnByEPS;
  TCheckBox *CBAutoEPS;
  TButton *ButtonSaveChanges;
  TTimer *Timer1;
  void __fastcall Exit1Click(TObject *Sender);
  void __fastcall About1Click(TObject *Sender);
  void __fastcall CSpinEditMatrixRowsChange(TObject *Sender);
  void __fastcall CSpinEditMatrixColsChange(TObject *Sender);
  void __fastcall BtnAddClick(TObject *Sender);
  void __fastcall LVMatrixChange(TObject *Sender, TListItem *Item,
          TItemChange Change);
  void __fastcall BtnPlusClick(TObject *Sender);
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall BtnIsClick(TObject *Sender);
  void __fastcall BtnMinClick(TObject *Sender);
  void __fastcall BtnMultClick(TObject *Sender);
  void __fastcall BtnDivClick(TObject *Sender);
  void __fastcall BtnTranClick(TObject *Sender);
  void __fastcall BtnEClick(TObject *Sender);
  void __fastcall BtnRemoveClick(TObject *Sender);
  void __fastcall BtnRndIntClick(TObject *Sender);
  void __fastcall BtnRndFloatClick(TObject *Sender);
  void __fastcall BtnTriClick(TObject *Sender);
  void __fastcall BtnLUClick(TObject *Sender);
  void __fastcall BtnDefClick(TObject *Sender);
  void __fastcall BtnInvClick(TObject *Sender);
  void __fastcall File1Click(TObject *Sender);
  void __fastcall Copy1Click(TObject *Sender);
  void __fastcall Paste1Click(TObject *Sender);
  void __fastcall BtnCtrlClick(TObject *Sender);
  void __fastcall Undo1Click(TObject *Sender);
  void __fastcall BtnByEPSClick(TObject *Sender);
  void __fastcall BtnFourierClick(TObject *Sender);
  void __fastcall ButtonSaveChangesClick(TObject *Sender);
  void __fastcall Timer1Timer(TObject *Sender);
private:	// User declarations
  CodeSymbol CurrCodeSymbol;
  void TestSingle();
  MatrixObject* __fastcall GridToMatrix();
  bool __fastcall MatrixToGrid(MatrixObject* mxCurrMatrix);
  bool CyrillicNotation;
public:		// User declarations
  MatrixObject* ActiveMatrixObject;
  MatrixObject* CurrMatrixObject;
  MatrixObject* MatrixUndo;
  MatrixObject* MatrixRedo;
  TListItem* ActiveListItem;
  enum MathCommand {
    None,
    Plus,
    Minus,
    Multiplication,
    Division,
    Transpose,
    Other
  } ActiveMathCommand;

  void __fastcall ShowError(const String& StrErrorText);
  String __fastcall GenerateName(const String& strPattern);
  TListItem* __fastcall IsInMatrixList(String strElem);
  void __fastcall AddToMatrixList(MatrixObject* CurrMatrix,const String& CurrMatrixCaption);
  bool __fastcall IsInMatrixList(MatrixObject* matrix);
  int __fastcall CountInStr(const String& Str,const String& Item);
  String __fastcall StrReplace(const String& Str,const String& What,const String& With);
  __fastcall TFormMain(TComponent* Owner);
};

//---------------------------------------------------------------------------
extern PACKAGE TFormMain *FormMain;
//---------------------------------------------------------------------------
#endif
